// Copyright (C) 2015 - Michael Baudin
//
// This file must be used under the terms of the 
// GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html

// Reference
// Numerical Mathematics, 
// Alfio Quarteroni, Riccardo Sacco, Fausto Saleri
// Example 10.1, p.437

function y=myfunction(x,alpha)
    y=abs(x).^(alpha+3/5)
endfunction
n=50
alpha=0
// With Scilab
I=intg(-1,1,list(myfunction,alpha))
// Chebyshev
[x,w]=chebyshev_integration(n);
y=myfunction(x,alpha);
weight=chebyshev_weight(x);
I=sum(y.*w./weight)
// Legendre
[x,w]=legendre_integration(n);
y=myfunction(x,alpha);
weight=legendre_weight(x);
I=sum(y.*w./weight)
